    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -----------------
    028     * AxisLocation.java
    029     * -----------------
    030     * (C) Copyright 2003-2007, by Object Refinery Limited and Contributors.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   Nick Guenther;
    034     *
    035     * $Id: AxisLocation.java,v 1.4.2.3 2007/03/22 10:59:34 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 02-May-2003 : Version 1 (DG);
    040     * 03-Jul-2003 : Added isTopOrBottom() and isLeftOrRight() methods (DG);
    041     * 13-Aug-2003 : Fixed readResolve() bug (id=788202) (DG);
    042     * 24-Mar-2004 : Added static getOpposite() method (DG);
    043     * ------------- JFREECHART 1.0.x ---------------------------------------------
    044     * 22-Mar-2007 : Added getOpposite() method, suggested by Nick Guenther (DG);
    045     *
    046     */
    047
    048    package org.jfree.chart.axis;
    049
    050    import java.io.ObjectStreamException;
    051    import java.io.Serializable;
    052
    053    /**
    054     * Used to indicate the location of an axis on a 2D plot, prior to knowing the
    055     * orientation of the plot.
    056     */
    057    public final class AxisLocation implements Serializable {
    058
    059        /** For serialization. */
    060        private static final long serialVersionUID = -3276922179323563410L;
    061
    062        /** Axis at the top or left. */
    063        public static final AxisLocation TOP_OR_LEFT = new AxisLocation(
    064                "AxisLocation.TOP_OR_LEFT");
    065
    066        /** Axis at the top or right. */
    067        public static final AxisLocation TOP_OR_RIGHT = new AxisLocation(
    068                "AxisLocation.TOP_OR_RIGHT");
    069
    070        /** Axis at the bottom or left. */
    071        public static final AxisLocation BOTTOM_OR_LEFT = new AxisLocation(
    072                "AxisLocation.BOTTOM_OR_LEFT");
    073
    074        /** Axis at the bottom or right. */
    075        public static final AxisLocation BOTTOM_OR_RIGHT = new AxisLocation(
    076                "AxisLocation.BOTTOM_OR_RIGHT");
    077
    078        /** The name. */
    079        private String name;
    080
    081        /**
    082         * Private constructor.
    083         *
    084         * @param name  the name.
    085         */
    086        private AxisLocation(String name) {
    087            this.name = name;
    088        }
    089
    090        /**
    091         * Returns the location that is opposite to this location.
    092         *
    093         * @return The opposite location.
    094         *
    095         * @since 1.0.5
    096         */
    097        public AxisLocation getOpposite() {
    098            return getOpposite(this);
    099        }
    100
    101        /**
    102         * Returns a string representing the object.
    103         *
    104         * @return The string.
    105         */
    106        public String toString() {
    107            return this.name;
    108        }
    109
    110        /**
    111         * Returns <code>true</code> if this object is equal to the specified
    112         * object, and <code>false</code> otherwise.
    113         *
    114         * @param obj  the other object (<code>null</code> permitted).
    115         *
    116         * @return A boolean.
    117         */
    118        public boolean equals(Object obj) {
    119
    120            if (this == obj) {
    121                return true;
    122            }
    123            if (!(obj instanceof AxisLocation)) {
    124                return false;
    125            }
    126            AxisLocation location = (AxisLocation) obj;
    127            if (!this.name.equals(location.toString())) {
    128                return false;
    129            }
    130            return true;
    131
    132        }
    133
    134        /**
    135         * Returns the location that is opposite to the supplied location.
    136         *
    137         * @param location  the location (<code>null</code> not permitted).
    138         *
    139         * @return The opposite location.
    140         */
    141        public static AxisLocation getOpposite(AxisLocation location) {
    142            if (location == null) {
    143                throw new IllegalArgumentException("Null 'location' argument.");
    144            }
    145            AxisLocation result = null;
    146            if (location == AxisLocation.TOP_OR_LEFT) {
    147                result = AxisLocation.BOTTOM_OR_RIGHT;
    148            }
    149            else if (location == AxisLocation.TOP_OR_RIGHT) {
    150                result = AxisLocation.BOTTOM_OR_LEFT;
    151            }
    152            else if (location == AxisLocation.BOTTOM_OR_LEFT) {
    153                result = AxisLocation.TOP_OR_RIGHT;
    154            }
    155            else if (location == AxisLocation.BOTTOM_OR_RIGHT) {
    156                result = AxisLocation.TOP_OR_LEFT;
    157            }
    158            else {
    159                throw new IllegalStateException("AxisLocation not recognised.");
    160            }
    161            return result;
    162        }
    163
    164        /**
    165         * Ensures that serialization returns the unique instances.
    166         *
    167         * @return The object.
    168         *
    169         * @throws ObjectStreamException if there is a problem.
    170         */
    171        private Object readResolve() throws ObjectStreamException {
    172            if (this.equals(AxisLocation.TOP_OR_RIGHT)) {
    173                return AxisLocation.TOP_OR_RIGHT;
    174            }
    175            else if (this.equals(AxisLocation.BOTTOM_OR_RIGHT)) {
    176                return AxisLocation.BOTTOM_OR_RIGHT;
    177            }
    178            else if (this.equals(AxisLocation.TOP_OR_LEFT)) {
    179                return AxisLocation.TOP_OR_LEFT;
    180            }
    181            else if (this.equals(AxisLocation.BOTTOM_OR_LEFT)) {
    182                return AxisLocation.BOTTOM_OR_LEFT;
    183            }
    184            return null;
    185        }
    186
    187    }